% number of patterns and features
num_pat = 100;
num_indep_feat = 500;
num_dep_feat = 1000;
num_repeat_feat = 1000;
num_useful_feat = 2; %<= num_indep_feat
flip_y = 0.1;

% Note: we could also be hiding a number of the useful features at the end

the_date = date;

ff=fopen([the_date '-profile.txt'], 'w');

fprintf(ff, 'Profile of the data set drawn %s\n\n', the_date);
fprintf(ff, 'Number of patterns: %d\n', num_pat);
fprintf(ff, 'Number of independent features: %d\n', num_indep_feat);
fprintf(ff, 'Number of dependent features: %d\n', num_dep_feat);
fprintf(ff, 'Number of repeated features: %d\n', num_repeat_feat);
fprintf(ff, 'Number of useful features: %d\n', num_useful_feat);
fprintf(ff, 'Fraction of flipped labels: %g\n', flip_y);
   

[X,Y,rp,fi] = p_y_given_x(num_pat,num_indep_feat,num_dep_feat,num_repeat_feat,num_useful_feat,flip_y);

% sort to display
num_feat=length(rp);
[ys, is]=sort(Y);
irp=zeros(size(rp));
irp(rp)=1:num_feat;
featdisplay([normalize_data(X(is,irp)),ys]);

save([the_date '-XY'], 'X', 'Y');
fprintf(ff, '\nIndices of flipped labels: \n');
fprintf(ff, '%d ',fi);
fprintf(ff, '\nIndices of useful features: \n');
fprintf(ff, '%d ',irp(1:num_useful_feat));
fprintf(ff, '\nIndices of useless features: \n');
fprintf(ff, '%d ',irp(num_useful_feat+1:num_indep_feat));
fprintf(ff, '\nThe others are either dependent or repeated\n\n');

fprintf(ff, 'Feature permutation matrix: \nrp=[\n');
fprintf(ff, '%d ',rp);
fprintf(ff, '\n]\n');

fclose(ff);



