function [Xtrain_norm, Xtest_norm] = normalize_data(Xtrain, Xtest)
%[Xtrain_norm, Xtest_norm] = normalize_data(Xtrain, Xtest)
% Normalize the training and test data
% by shifting the mean of Xtrain to zero and rescaling the stdev to one.
% If Xtest is specified, the same shift and scaling are applied to Xtest.

% Isabelle Guyon, last change Jan 2001, isabelle@clopinet.com
% Changed std to divide by N, not N-1.

Mean = mean(Xtrain);
Stdev = std(Xtrain,1);
Stdev(Stdev==0)=1;

[p,n]=size(Xtrain);
for i=1:p
   Xtrain_norm(i,:) = (Xtrain(i,:)-Mean)./Stdev;
end

if nargin>1
	[p,n]=size(Xtest);
	for i=1:p
	   Xtest_norm(i,:) = (Xtest(i,:)-Mean)./Stdev;
	end
	%Max = max(max(Xtrain_norm));
	%Min = min(min(Xtrain_norm));
	%Xtest_norm(Xtest_norm>Max)=Max;
	%Xtest_norm(Xtest_norm<Min)=Min;
end

